--- old/usr/src/cmd/sendmail/libsm/vprintf.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsm/vprintf.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: vprintf.c,v 1.12 2001/01/24 01:27:26 gshapiro Exp $")
+SM_RCSID("@(#)$Id: vprintf.c,v 1.15 2013-11-22 20:51:44 ca Exp $")
 #include <sm/io.h>
 #include "local.h"
 
--- old/usr/src/cmd/sendmail/libsm/vsnprintf.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsm/vsnprintf.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: vsnprintf.c,v 1.21 2001/03/04 23:28:41 ca Exp $")
+SM_RCSID("@(#)$Id: vsnprintf.c,v 1.24 2013-11-22 20:51:44 ca Exp $")
 #include <limits.h>
 #include <sm/io.h>
 #include "local.h"
--- old/usr/src/cmd/sendmail/libsm/wbuf.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsm/wbuf.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: wbuf.c,v 1.19 2001/03/05 03:22:41 ca Exp $")
+SM_RCSID("@(#)$Id: wbuf.c,v 1.22 2013-11-22 20:51:44 ca Exp $")
 #include <errno.h>
 #include <sm/io.h>
 #include "local.h"
--- old/usr/src/cmd/sendmail/libsm/wsetup.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsm/wsetup.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2002 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -12,10 +12,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: wsetup.c,v 1.20 2002/02/07 18:02:45 ca Exp $")
+SM_RCSID("@(#)$Id: wsetup.c,v 1.21 2013-11-22 20:51:44 ca Exp $")
 #include <stdlib.h>
 #include <errno.h>
 #include <sm/io.h>
--- old/usr/src/cmd/sendmail/libsm/xtrap.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsm/xtrap.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: xtrap.c,v 1.3 2000/12/08 08:03:09 rodney Exp $")
+SM_RCSID("@(#)$Id: xtrap.c,v 1.6 2013-11-22 20:51:44 ca Exp $")
 
 #include <sm/xtrap.h>
 
--- old/usr/src/cmd/sendmail/libsmdb/smdb.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsmdb/smdb.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
-** Copyright (c) 1999-2002 Sendmail, Inc. and its suppliers.
+** Copyright (c) 1999-2002 Proofpoint, Inc. and its suppliers.
 **	All rights reserved.
 **
 ** By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
 ** the sendmail distribution.
 */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: smdb.c,v 8.58 2004/08/03 20:58:38 ca Exp $")
+SM_RCSID("@(#)$Id: smdb.c,v 8.59 2013-11-22 20:51:49 ca Exp $")
 
 #include <fcntl.h>
 #include <stdlib.h>
--- old/usr/src/cmd/sendmail/libsmdb/smdb1.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsmdb/smdb1.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
-** Copyright (c) 1999-2002, 2004, 2009 Sendmail, Inc. and its suppliers.
+** Copyright (c) 1999-2002, 2004, 2009 Proofpoint, Inc. and its suppliers.
 **	All rights reserved.
 **
 ** By using this file, you agree to the terms and conditions set
@@ -8,7 +8,7 @@
 */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: smdb1.c,v 8.62 2009/11/12 23:04:18 ca Exp $")
+SM_RCSID("@(#)$Id: smdb1.c,v 8.63 2013-11-22 20:51:49 ca Exp $")
 
 #include <unistd.h>
 #include <stdlib.h>
--- old/usr/src/cmd/sendmail/libsmdb/smdb2.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsmdb/smdb2.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
-** Copyright (c) 1999-2003, 2009 Sendmail, Inc. and its suppliers.
+** Copyright (c) 1999-2003, 2009 Proofpoint, Inc. and its suppliers.
 **	All rights reserved.
 **
 ** By using this file, you agree to the terms and conditions set
@@ -8,7 +8,7 @@
 */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: smdb2.c,v 8.80 2009/11/12 23:07:49 ca Exp $")
+SM_RCSID("@(#)$Id: smdb2.c,v 8.83 2013-11-22 20:51:49 ca Exp $")
 
 #include <fcntl.h>
 #include <stdlib.h>
@@ -625,6 +625,8 @@
 	{
 		smdb_unlock_file(lock_fd);
 		smdb_free_database(smdb_db);	/* ok to be NULL */
+		if (db2 != NULL)
+			free(db2);
 		return SMDBE_MALLOC;
 	}
 
--- old/usr/src/cmd/sendmail/libsmdb/smndbm.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsmdb/smndbm.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
-** Copyright (c) 1999-2002 Sendmail, Inc. and its suppliers.
+** Copyright (c) 1999-2002 Proofpoint, Inc. and its suppliers.
 **	All rights reserved.
 **
 ** By using this file, you agree to the terms and conditions set
@@ -7,10 +7,8 @@
 ** the sendmail distribution.
 */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: smndbm.c,v 8.52 2002/05/21 22:30:30 gshapiro Exp $")
+SM_RCSID("@(#)$Id: smndbm.c,v 8.55 2013-11-22 20:51:49 ca Exp $")
 
 #include <fcntl.h>
 #include <stdlib.h>
@@ -440,6 +438,8 @@
 
 	db->smndbm_cursor_in_use = true;
 	dbm_cursor = (SMDB_DBM_CURSOR *) malloc(sizeof(SMDB_DBM_CURSOR));
+	if (dbm_cursor == NULL)
+		return SMDBE_MALLOC;
 	dbm_cursor->smndbmc_db = db;
 	dbm_cursor->smndbmc_current_key.dptr = NULL;
 	dbm_cursor->smndbmc_current_key.dsize = 0;
@@ -446,7 +446,10 @@
 
 	cur = (SMDB_CURSOR*) malloc(sizeof(SMDB_CURSOR));
 	if (cur == NULL)
+	{
+		free(dbm_cursor);
 		return SMDBE_MALLOC;
+	}
 
 	cur->smdbc_impl = dbm_cursor;
 	cur->smdbc_close = smdbm_cursor_close;
--- old/usr/src/cmd/sendmail/libsmutil/cf.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsmutil/cf.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2002 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
-SM_RCSID("@(#)$Id: cf.c,v 8.18.2.1 2002/09/24 21:48:23 ca Exp $")
+SM_RCSID("@(#)$Id: cf.c,v 8.20 2013-11-22 20:51:50 ca Exp $")
 #include <sendmail/pathnames.h>
 
 /*
--- old/usr/src/cmd/sendmail/libsmutil/debug.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsmutil/debug.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: debug.c,v 8.7 2001/06/27 21:46:54 gshapiro Exp $")
+SM_RCSID("@(#)$Id: debug.c,v 8.10 2013-11-22 20:51:50 ca Exp $")
 
 unsigned char	tTdvect[100];	/* trace vector */
--- old/usr/src/cmd/sendmail/libsmutil/err.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsmutil/err.c	Sat Feb  6 15:36:42 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,11 +8,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: err.c,v 8.3 2001/01/24 01:27:30 gshapiro Exp $")
+SM_RCSID("@(#)$Id: err.c,v 8.6 2013-11-22 20:51:50 ca Exp $")
 
 #include <ctype.h>
 
--- old/usr/src/cmd/sendmail/libsmutil/lockfile.c	Sat Feb  6 15:36:42 2016
+++ new/usr/src/cmd/sendmail/libsmutil/lockfile.c	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: lockfile.c,v 8.21 2003/11/10 22:57:38 ca Exp $")
+SM_RCSID("@(#)$Id: lockfile.c,v 8.22 2013-11-22 20:51:50 ca Exp $")
 
 
 /*
--- old/usr/src/cmd/sendmail/libsmutil/safefile.c	Sat Feb  6 15:36:43 2016
+++ new/usr/src/cmd/sendmail/libsmutil/safefile.c	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2004 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2004 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -15,7 +15,7 @@
 #include <sm/io.h>
 #include <sm/errstring.h>
 
-SM_RCSID("@(#)$Id: safefile.c,v 8.129 2008/08/04 18:07:04 gshapiro Exp $")
+SM_RCSID("@(#)$Id: safefile.c,v 8.130 2013-11-22 20:51:50 ca Exp $")
 
 
 /*
--- old/usr/src/cmd/sendmail/libsmutil/snprintf.c	Sat Feb  6 15:36:43 2016
+++ new/usr/src/cmd/sendmail/libsmutil/snprintf.c	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,13 +11,11 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: snprintf.c,v 8.41 2001/08/28 23:07:01 gshapiro Exp $")
+SM_RCSID("@(#)$Id: snprintf.c,v 8.45 2013-11-22 20:51:50 ca Exp $")
 
-/*
+/*
 **  SHORTENSTRING -- return short version of a string
 **
 **	If the string is already short, just return it.  If it is too
--- old/usr/src/cmd/sendmail/src/alias.c	Sat Feb  6 15:36:43 2016
+++ new/usr/src/cmd/sendmail/src/alias.c	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2003 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2003 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: alias.c,v 8.219 2006/10/24 18:04:09 ca Exp $")
+SM_RCSID("@(#)$Id: alias.c,v 8.221 2013-11-22 20:51:54 ca Exp $")
 
 #define SEPARATOR ':'
 # define ALIAS_SPEC_SEPARATORS	" ,/:"
@@ -659,7 +657,7 @@
 	LineNumber = 0;
 	naliases = bytes = longest = 0;
 	skipping = false;
-	while (sm_io_fgets(af, SM_TIME_DEFAULT, line, sizeof(line)) != NULL)
+	while (sm_io_fgets(af, SM_TIME_DEFAULT, line, sizeof(line)) >= 0)
 	{
 		int lhssize, rhssize;
 		int c;
@@ -672,7 +670,7 @@
 		{
 			p--;
 			if (sm_io_fgets(af, SM_TIME_DEFAULT, p,
-					SPACELEFT(line, p)) == NULL)
+					SPACELEFT(line, p)) < 0)
 				break;
 			LineNumber++;
 			p = strchr(p, '\n');
@@ -782,7 +780,7 @@
 
 			/* read continuation line */
 			if (sm_io_fgets(af, SM_TIME_DEFAULT, p,
-					sizeof(line) - (p-line)) == NULL)
+					sizeof(line) - (p-line)) < 0)
 				break;
 			LineNumber++;
 
--- old/usr/src/cmd/sendmail/src/arpadate.c	Sat Feb  6 15:36:43 2016
+++ new/usr/src/cmd/sendmail/src/arpadate.c	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: arpadate.c,v 8.31 2006/08/15 23:24:55 ca Exp $")
+SM_RCSID("@(#)$Id: arpadate.c,v 8.32 2013-11-22 20:51:55 ca Exp $")
 
 /*
 **  ARPADATE -- Create date in ARPANET format
--- old/usr/src/cmd/sendmail/src/bf.c	Sat Feb  6 15:36:43 2016
+++ new/usr/src/cmd/sendmail/src/bf.c	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999-2002, 2004, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999-2002, 2004, 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -10,8 +10,6 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  This is in transition. Changed from the original bf_torek.c code
 **  to use sm_io function calls directly rather than through stdio
@@ -20,7 +18,7 @@
 */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: bf.c,v 8.62 2006/03/31 18:45:56 ca Exp $")
+SM_RCSID("@(#)$Id: bf.c,v 8.63 2013-11-22 20:51:55 ca Exp $")
 
 #include <sys/types.h>
 #include <sys/stat.h>
--- old/usr/src/cmd/sendmail/src/bf.h	Sat Feb  6 15:36:43 2016
+++ new/usr/src/cmd/sendmail/src/bf.h	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999-2002 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,14 +6,12 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: bf.h,v 8.16 2002/04/15 02:37:09 ca Exp $
+ *	$Id: bf.h,v 8.17 2013-11-22 20:51:55 ca Exp $
  *
  * Contributed by Exactis.com, Inc.
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef BF_H
 # define BF_H 1
 
--- old/usr/src/cmd/sendmail/src/collect.c	Sat Feb  6 15:36:43 2016
+++ new/usr/src/cmd/sendmail/src/collect.c	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2006, 2008 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2006, 2008 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -13,7 +13,7 @@
 
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: collect.c,v 8.284 2008/08/06 05:26:24 ca Exp $")
+SM_RCSID("@(#)$Id: collect.c,v 8.287 2013-11-22 20:51:55 ca Exp $")
 
 static void	eatfrom __P((char *volatile, ENVELOPE *));
 static void	collect_doheader __P((ENVELOPE *));
@@ -300,6 +300,9 @@
 	unsigned char *pbp;
 	unsigned char peekbuf[8];
 	char bufbuf[MAXLINE];
+#if _FFR_REJECT_NUL_BYTE
+	bool hasNUL;		/* has at least one NUL input byte */
+#endif /* _FFR_REJECT_NUL_BYTE */
 
 	df = NULL;
 	ignrdot = smtpmode ? false : IgnrDot;
@@ -315,6 +318,9 @@
 	hdrslen = 0;
 	numhdrs = 0;
 	HasEightBits = false;
+#if _FFR_REJECT_NUL_BYTE
+	hasNUL = false;
+#endif /* _FFR_REJECT_NUL_BYTE */
 	buf = bp = bufbuf;
 	buflen = sizeof(bufbuf);
 	pbp = peekbuf;
@@ -403,6 +409,10 @@
 							SM_TIME_DEFAULT,
 							c);
 				}
+#if _FFR_REJECT_NUL_BYTE
+				if (c == '\0')
+					hasNUL = true;
+#endif /* _FFR_REJECT_NUL_BYTE */
 				if (c == SM_IO_EOF)
 					goto readerr;
 				if (SevenBitInput)
@@ -869,7 +879,8 @@
 			if (LogLevel > 6)
 				sm_syslog(LOG_NOTICE, e->e_id,
 					"message size (%ld) exceeds maximum (%ld)",
-					e->e_msgsize, MaxMessageSize);
+					PRT_NONNEGL(e->e_msgsize),
+					MaxMessageSize);
 		}
 	}
 
@@ -892,6 +903,14 @@
 			e->e_bodytype = "7BIT";
 	}
 
+#if _FFR_REJECT_NUL_BYTE
+	if (hasNUL && RejectNUL)
+	{
+		e->e_status = "5.6.1";
+		usrerrenh(e->e_status, "554 NUL byte not allowed");
+	}
+#endif /* _FFR_REJECT_NUL_BYTE */
+
 	if (SuperSafe == SAFE_REALLY && !bitset(EF_FATALERRS, e->e_flags))
 	{
 		char *dfname = queuename(e, DATAFL_LETTER);
--- old/usr/src/cmd/sendmail/src/conf.c	Sat Feb  6 15:36:43 2016
+++ new/usr/src/cmd/sendmail/src/conf.c	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2013 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,14 +11,9 @@
  *
  */
 
-/*
- * Copyright 1999-2006 Sun Microsystems, Inc.  All rights reserved.
- * Use is subject to license terms.
- */
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: conf.c,v 8.1153 2009/12/18 17:25:12 ca Exp $")
+SM_RCSID("@(#)$Id: conf.c,v 8.1191 2014-01-08 17:03:14 ca Exp $")
 
 #include <sm/sendmail.h>
 #include <sendmail/pathnames.h>
@@ -55,8 +50,11 @@
 static int	add_hostnames __P((SOCKADDR *));
 
 #if NETINET6 && NEEDSGETIPNODE
-static struct hostent *getipnodebyname __P((char *, int, int, int *));
-static struct hostent *getipnodebyaddr __P((char *, int, int, int *));
+static struct hostent *sm_getipnodebyname __P((const char *, int, int, int *));
+static struct hostent *sm_getipnodebyaddr __P((const void *, size_t, int, int *));
+#else /* NETINET6 && NEEDSGETIPNODE */
+#define sm_getipnodebyname getipnodebyname
+#define sm_getipnodebyaddr getipnodebyaddr
 #endif /* NETINET6 && NEEDSGETIPNODE */
 
 
@@ -667,6 +665,13 @@
 		dequote_init, null_map_open, null_map_close,
 		arith_map_lookup, null_map_store);
 
+#if _FFR_ARPA_MAP
+	/* "arpa" map -- IP -> arpa */
+	MAPDEF("arpa", NULL, 0,
+		dequote_init, null_map_open, null_map_close,
+		arpa_map_lookup, null_map_store);
+#endif /* _FFR_ARPA_MAP */
+
 #if SOCKETMAP
 	/* arbitrary daemons */
 	MAPDEF("socket", NULL, MCF_ALIASOK,
@@ -969,7 +974,7 @@
 			char buf[MAXLINE];
 
 			while (sm_io_fgets(fp, SM_TIME_DEFAULT, buf,
-					   sizeof(buf)) != NULL)
+					   sizeof(buf)) >= 0)
 			{
 				register char *p;
 
@@ -2605,7 +2610,7 @@
 **		none.
 */
 
-/*VARARGS2*/
+/*VARARGS3*/
 void
 #ifdef __STDC__
 sm_setproctitle(bool status, ENVELOPE *e, const char *fmt, ...)
@@ -2850,7 +2855,7 @@
 		char buf[MAXLINE];
 
 		while (sm_io_fgets(file, SM_TIME_DEFAULT,
-				   buf, sizeof(buf)) != NULL)
+				   buf, sizeof(buf)) >= 0)
 		{
 			if (sm_io_sscanf(buf, "#define sysname \"%*[^\"]\"",
 					NODE_LENGTH, name->nodename) > 0)
@@ -3224,7 +3229,7 @@
 		return false;
 	}
 
-	while (sm_io_fgets(shellf, SM_TIME_DEFAULT, buf, sizeof(buf)) != NULL)
+	while (sm_io_fgets(shellf, SM_TIME_DEFAULT, buf, sizeof(buf)) >= 0)
 	{
 		register char *p, *q;
 
@@ -4193,7 +4198,7 @@
 /*
 **  SM_GETHOSTBY{NAME,ADDR} -- compatibility routines for gethostbyXXX
 **
-**	Some operating systems have wierd problems with the gethostbyXXX
+**	Some operating systems have weird problems with the gethostbyXXX
 **	routines.  For example, Solaris versions at least through 2.3
 **	don't properly deliver a canonical h_name field.  This tries to
 **	work around these problems.
@@ -4217,15 +4222,23 @@
 # endif /* ! AI_ALL */
 
 static struct hostent *
-getipnodebyname(name, family, flags, err)
-	char *name;
+sm_getipnodebyname(name, family, flags, err)
+	const char *name;
 	int family;
 	int flags;
 	int *err;
 {
-	bool resv6 = true;
 	struct hostent *h;
+# if HAS_GETHOSTBYNAME2
 
+	h = gethostbyname2(name, family);
+	if (h == NULL)
+		*err = h_errno;
+	return h;
+
+# else /* HAS_GETHOSTBYNAME2 */
+	bool resv6 = true;
+
 	if (family == AF_INET6)
 	{
 		/* From RFC2133, section 6.1 */
@@ -4236,14 +4249,26 @@
 	h = gethostbyname(name);
 	if (!resv6)
 		_res.options &= ~RES_USE_INET6;
-	*err = h_errno;
+
+	/* the function is supposed to return only the requested family */
+	if (h != NULL && h->h_addrtype != family)
+	{
+#  if NETINET6
+		freehostent(h);
+#  endif /* NETINET6 */
+		h = NULL;
+		*err = NO_DATA;
+	}
+	else
+		*err = h_errno;
 	return h;
+# endif /* HAS_GETHOSTBYNAME2 */
 }
 
 static struct hostent *
-getipnodebyaddr(addr, len, family, err)
-	char *addr;
-	int len;
+sm_getipnodebyaddr(addr, len, family, err)
+	const void *addr;
+	size_t len;
 	int family;
 	int *err;
 {
@@ -4296,7 +4321,12 @@
 #else /* (SOLARIS > 10000 && SOLARIS < 20400) || (defined(SOLARIS) && SOLARIS < 204) || (defined(sony_news) && defined(__svr4)) */
 	int nmaps;
 # if NETINET6
-	int flags = AI_DEFAULT|AI_ALL;
+#  ifndef SM_IPNODEBYNAME_FLAGS
+    /* For IPv4-mapped addresses, use: AI_DEFAULT|AI_ALL */
+#   define SM_IPNODEBYNAME_FLAGS	AI_ADDRCONFIG
+#  endif /* SM_IPNODEBYNAME_FLAGS */
+
+	int flags = SM_IPNODEBYNAME_FLAGS;
 	int err;
 # endif /* NETINET6 */
 	char *maptype[MAXMAPSTACK];
@@ -4310,7 +4340,7 @@
 #  if ADDRCONFIG_IS_BROKEN
 	flags &= ~AI_ADDRCONFIG;
 #  endif /* ADDRCONFIG_IS_BROKEN */
-	h = getipnodebyname(name, family, flags, &err);
+	h = sm_getipnodebyname(name, family, flags, &err);
 	SM_SET_H_ERRNO(err);
 # else /* NETINET6 */
 	h = gethostbyname(name);
@@ -4349,7 +4379,7 @@
 					       hbuf, family);
 
 # if NETINET6
-				h = getipnodebyname(hbuf, family, flags, &err);
+				h = sm_getipnodebyname(hbuf, family, flags, &err);
 				SM_SET_H_ERRNO(err);
 				save_errno = errno;
 # else /* NETINET6 */
@@ -4360,6 +4390,17 @@
 		}
 	}
 #endif /* (SOLARIS > 10000 && SOLARIS < 20400) || (defined(SOLARIS) && SOLARIS < 204) || (defined(sony_news) && defined(__svr4)) */
+
+	/* the function is supposed to return only the requested family */
+	if (h != NULL && h->h_addrtype != family)
+	{
+# if NETINET6
+		freehostent(h);
+# endif /* NETINET6 */
+		h = NULL;
+		SM_SET_H_ERRNO(NO_DATA);
+	}
+
 	if (tTd(61, 10))
 	{
 		if (h == NULL)
@@ -4369,13 +4410,12 @@
 			sm_dprintf("%s\n", h->h_name);
 			if (tTd(61, 11))
 			{
+				struct in_addr ia;
+				size_t i;
 #if NETINET6
 				struct in6_addr ia6;
 				char buf6[INET6_ADDRSTRLEN];
-#else /* NETINET6 */
-				struct in_addr ia;
 #endif /* NETINET6 */
-				size_t i;
 
 				if (h->h_aliases != NULL)
 					for (i = 0; h->h_aliases[i] != NULL;
@@ -4386,16 +4426,23 @@
 				{
 					char *addr;
 
+					addr = NULL;
 #if NETINET6
-					memmove(&ia6, h->h_addr_list[i],
-						IN6ADDRSZ);
-					addr = anynet_ntop(&ia6,
-							   buf6, sizeof(buf6));
-#else /* NETINET6 */
-					memmove(&ia, h->h_addr_list[i],
-						INADDRSZ);
-					addr = (char *) inet_ntoa(ia);
+					if (h->h_addrtype == AF_INET6)
+					{
+						memmove(&ia6, h->h_addr_list[i],
+							IN6ADDRSZ);
+						addr = anynet_ntop(&ia6,
+							buf6, sizeof(buf6));
+					}
+					else
 #endif /* NETINET6 */
+					/* "else" in #if code above */
+					{
+						memmove(&ia, h->h_addr_list[i],
+							INADDRSZ);
+						addr = (char *) inet_ntoa(ia);
+					}
 					if (addr != NULL)
 						sm_dprintf("\taddr: %s\n", addr);
 				}
@@ -4446,7 +4493,7 @@
 	{
 		int err;
 
-		hp = getipnodebyaddr(addr, len, type, &err);
+		hp = sm_getipnodebyaddr(addr, len, type, &err);
 		SM_SET_H_ERRNO(err);
 	}
 # else /* NETINET6 */
@@ -4604,6 +4651,10 @@
 		int save_errno = errno;
 
 		if (LogLevel > 3 &&
+#if NETINET && defined(IN_LINKLOCAL)
+		    !(sa->sa.sa_family == AF_INET &&
+		      IN_LINKLOCAL(ntohl(sa->sin.sin_addr.s_addr))) &&
+#endif /* NETINET && defined(IN_LINKLOCAL) */
 #if NETINET6
 		    !(sa->sa.sa_family == AF_INET6 &&
 		      IN6_IS_ADDR_LINKLOCAL(&sa->sin6.sin6_addr)) &&
@@ -4869,6 +4920,7 @@
 		switch (af)
 		{
 		  case AF_INET6:
+			SETV6LOOPBACKADDRFOUND(*sa);
 #  ifdef __KAME__
 			/* convert into proper scoped address */
 			if ((IN6_IS_ADDR_LINKLOCAL(&sa->sin6.sin6_addr) ||
@@ -5068,6 +5120,7 @@
 
 #   if NETINET6
 		  case AF_INET6:
+			SETV6LOOPBACKADDRFOUND(*sa);
 #    ifdef __KAME__
 			/* convert into proper scoped address */
 			if ((IN6_IS_ADDR_LINKLOCAL(&sa->sin6.sin6_addr) ||
@@ -5256,8 +5309,8 @@
 */
 
 void
-sm_close_on_exec(highest, lowest)
-	int highest, lowest;
+sm_close_on_exec(lowest, highest)
+	int lowest, highest;
 {
 #if HASFDWALK
 	(void) fdwalk(closefd_walk, &lowest);
@@ -5374,7 +5427,15 @@
 #if LOG
 		if (*id == '\0')
 		{
-			if (tTd(89, 8))
+			if (tTd(89, 10))
+			{
+				struct timeval tv;
+
+				gettimeofday(&tv, NULL);
+				sm_dprintf("%ld.%06ld %s\n", (long) tv.tv_sec,
+					(long) tv.tv_usec, newstring);
+			}
+			else if (tTd(89, 8))
 				sm_dprintf("%s\n", newstring);
 			else
 				syslog(level, "%s", newstring);
@@ -5381,7 +5442,15 @@
 		}
 		else
 		{
-			if (tTd(89, 8))
+			if (tTd(89, 10))
+			{
+				struct timeval tv;
+
+				gettimeofday(&tv, NULL);
+				sm_dprintf("%ld.%06ld %s: %s\n", (long) tv.tv_sec,
+					(long) tv.tv_usec, id, newstring);
+			}
+			else if (tTd(89, 8))
 				sm_dprintf("%s: %s\n", id, newstring);
 			else
 				syslog(level, "%s: %s", id, newstring);
@@ -5933,6 +6002,9 @@
 #if HASWAITPID
 	"HASWAITPID",
 #endif /* HASWAITPID */
+#if HAVE_NANOSLEEP
+	"HAVE_NANOSLEEP",
+#endif /* HAVE_NANOSLEEP */
 #if IDENTPROTO
 	"IDENTPROTO",
 #endif /* IDENTPROTO */
@@ -5981,6 +6053,23 @@
 #if SECUREWARE
 	"SECUREWARE",
 #endif /* SECUREWARE */
+#if SFS_TYPE == SFS_4ARGS
+	"SFS_4ARGS",
+#elif SFS_TYPE == SFS_MOUNT
+	"SFS_MOUNT",
+#elif SFS_TYPE == SFS_NONE
+	"SFS_NONE",
+#elif SFS_TYPE == SFS_NT
+	"SFS_NT",
+#elif SFS_TYPE == SFS_STATFS
+	"SFS_STATFS",
+#elif SFS_TYPE == SFS_STATVFS
+	"SFS_STATVFS",
+#elif SFS_TYPE == SFS_USTAT
+	"SFS_USTAT",
+#elif SFS_TYPE == SFS_VFS
+	"SFS_VFS",
+#endif
 #if SHARE_V1
 	"SHARE_V1",
 #endif /* SHARE_V1 */
@@ -6023,6 +6112,9 @@
 #ifdef USESYSCTL
 	"USESYSCTL",
 #endif /* USESYSCTL */
+#if USE_OPENSSL_ENGINE
+	"USE_OPENSSL_ENGINE",
+#endif /* USE_OPENSSL_ENGINE */
 #if USING_NETSCAPE_LDAP
 	"USING_NETSCAPE_LDAP",
 #endif /* USING_NETSCAPE_LDAP */
@@ -6047,6 +6139,10 @@
 	/* DefaultAuthInfo doesn't really work in 8.13 anymore. */
 	"_FFR_ALLOW_SASLINFO",
 #endif /* _FFR_ALLOW_SASLINFO */
+#if _FFR_ARPA_MAP
+	/* arpa map to reverse an IPv(4,6) address */
+	"_FFR_ARPA_MAP",
+#endif /* _FFR_ARPA_MAP */
 #if _FFR_BADRCPT_SHUTDOWN
 	/* shut down connection (421) if there are too many bad RCPTs */
 	"_FFR_BADRCPT_SHUTDOWN",
@@ -6158,6 +6254,10 @@
 
 	"_FFR_GETHBN_ExFILE",
 #endif /* _FFR_GETHBN_ExFILE */
+#if _FFR_FIPSMODE
+	/* FIPSMode (if supported by OpenSSL library) */
+	"_FFR_FIPSMODE",
+#endif /* _FFR_FIPSMODE */
 #if _FFR_FIX_DASHT
 	/*
 	**  If using -t, force not sending to argv recipients, even
@@ -6199,6 +6299,10 @@
 	/* Ignore extensions offered in response to HELO */
 	"_FFR_IGNORE_EXT_ON_HELO",
 #endif /* _FFR_IGNORE_EXT_ON_HELO */
+#if _FFR_IPV6_FULL
+	/* Use uncompressed IPv6 address format (no "::") */
+	"_FFR_IPV6_FULL",
+#endif /* _FFR_IPV6_FULL */
 #if _FFR_LINUX_MHNL
 	/* Set MAXHOSTNAMELEN to 256 (Linux) */
 	"_FFR_LINUX_MHNL",
@@ -6326,7 +6430,7 @@
 #endif /* _FFR_QUEUE_SCHED_DBG */
 #if _FFR_RCPTTHROTDELAY
 	/* configurable delay for BadRcptThrottle */
-	"_FFR_RCPTTHROTDELAY"
+	"_FFR_RCPTTHROTDELAY",
 #endif /* _FFR_RCPTTHROTDELAY */
 #if _FFR_REDIRECTEMPTY
 	/*
@@ -6337,6 +6441,10 @@
 
 	"_FFR_REDIRECTEMPTY",
 #endif /* _FFR_REDIRECTEMPTY */
+#if _FFR_REJECT_NUL_BYTE
+	/* reject NUL bytes in body */
+	"_FFR_REJECT_NUL_BYTE",
+#endif /* _FFR_REJECT_NUL_BYTE */
 #if _FFR_RESET_MACRO_GLOBALS
 	/* Allow macro 'j' to be set dynamically via rulesets. */
 	"_FFR_RESET_MACRO_GLOBALS",
@@ -6416,6 +6524,9 @@
 	/* More STARTTLS options, e.g., secondary certs. */
 	"_FFR_TLS_1",
 #endif /* _FFR_TLS_1 */
+#if _FFR_TLS_EC
+	"_FFR_TLS_EC",
+#endif /* _FFR_TLS_EC */
 #if _FFR_TRUSTED_QF
 	/*
 	**  If we don't own the file mark it as unsafe.
@@ -6425,6 +6536,16 @@
 
 	"_FFR_TRUSTED_QF",
 #endif /* _FFR_TRUSTED_QF */
+#if _FFR_USE_GETPWNAM_ERRNO
+	/*
+	**  See libsm/mbdb.c: only enable this on OSs
+	**  that implement the correct (POSIX) semantics.
+	**  This will need to become an OS-specific #if enabled
+	**  in one of the headers files under include/sm/os/ .
+	*/
+
+	"_FFR_USE_GETPWNAM_ERRNO",
+#endif /* _FFR_USE_GETPWNAM_ERRNO */
 #if _FFR_USE_SEM_LOCKING
 	"_FFR_USE_SEM_LOCKING",
 #endif /* _FFR_USE_SEM_LOCKING */
--- old/usr/src/cmd/sendmail/src/conf.h	Sat Feb  6 15:36:43 2016
+++ new/usr/src/cmd/sendmail/src/conf.h	Sat Feb  6 15:36:43 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2002 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -10,7 +10,7 @@
  * the sendmail distribution.
  *
  *
- *	$Id: conf.h,v 8.575 2009/03/25 20:04:00 ca Exp $
+ *	$Id: conf.h,v 8.577 2013-11-22 20:51:55 ca Exp $
  */
 
 /*
@@ -112,7 +112,9 @@
 #ifndef MAXHDRSLEN
 # define MAXHDRSLEN	(32 * 1024)	/* max size of message headers */
 #endif /* ! MAXHDRSLEN */
-#define MAXDAEMONS	10		/* max number of ports to listen to */
+#ifndef MAXDAEMONS
+# define MAXDAEMONS	10		/* max number of ports to listen to */
+#endif /* MAXDAEMONS */
 #ifndef MAXINTERFACES
 # define MAXINTERFACES	512		/* number of interfaces to probe */
 #endif /* MAXINTERFACES */
--- old/usr/src/cmd/sendmail/src/control.c	Sat Feb  6 15:36:44 2016
+++ new/usr/src/cmd/sendmail/src/control.c	Sat Feb  6 15:36:44 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2004, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2004, 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,11 +8,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: control.c,v 8.128 2006/08/15 23:24:56 ca Exp $")
+SM_RCSID("@(#)$Id: control.c,v 8.130 2013-11-22 20:51:55 ca Exp $")
 
 #include <sm/fdset.h>
 
@@ -303,7 +301,7 @@
 	(void) sm_io_setvbuf(s, SM_TIME_DEFAULT, NULL,
 			     SM_IO_NBF, SM_IO_BUFSIZ);
 
-	if (sm_io_fgets(s, SM_TIME_DEFAULT, inp, sizeof(inp)) == NULL)
+	if (sm_io_fgets(s, SM_TIME_DEFAULT, inp, sizeof(inp)) < 0)
 	{
 		(void) sm_io_close(s, SM_TIME_DEFAULT);
 		exit(EX_IOERR);
--- old/usr/src/cmd/sendmail/src/convtime.c	Sat Feb  6 15:36:44 2016
+++ new/usr/src/cmd/sendmail/src/convtime.c	Sat Feb  6 15:36:44 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: convtime.c,v 8.36 2001/02/13 22:32:08 ca Exp $")
+SM_RCSID("@(#)$Id: convtime.c,v 8.40 2013-11-22 20:51:55 ca Exp $")
 
 /*
 **  CONVTIME -- convert time
@@ -100,7 +98,7 @@
 
 	return pos ? r : -r;
 }
-/*
+/*
 **  PINTVL -- produce printable version of a time interval
 **
 **	Parameters:
